
module advanceddelegate.base;

class AdvancedDelegate0(R)
{
    abstract R Eval();
}

class AdvancedDelegate1(R, P1)
{
    abstract R Eval(P1);
    abstract AdvancedDelegate0!(R) opCall(P1);
}

class AdvancedDelegate2(R, P1, P2)
{
    abstract R Eval(P1, P2);
    abstract AdvancedDelegate1!(R, P2) opCall(P1);
    abstract AdvancedDelegate0!(R) opCall(P1, P2);
}

class AdvancedDelegate3(R, P1, P2, P3)
{
    abstract R Eval(P1, P2, P3);
    abstract AdvancedDelegate2!(R, P2, P3) opCall(P1);
    abstract AdvancedDelegate1!(R, P3) opCall(P1, P2);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3);
}

class AdvancedDelegate4(R, P1, P2, P3, P4)
{
    abstract R Eval(P1, P2, P3, P4);
    abstract AdvancedDelegate3!(R, P2, P3, P4) opCall(P1);
    abstract AdvancedDelegate2!(R, P3, P4) opCall(P1, P2);
    abstract AdvancedDelegate1!(R, P4) opCall(P1, P2, P3);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4);
}

class AdvancedDelegate5(R, P1, P2, P3, P4, P5)
{
    abstract R Eval(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate4!(R, P2, P3, P4, P5) opCall(P1);
    abstract AdvancedDelegate3!(R, P3, P4, P5) opCall(P1, P2);
    abstract AdvancedDelegate2!(R, P4, P5) opCall(P1, P2, P3);
    abstract AdvancedDelegate1!(R, P5) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5);
}

class AdvancedDelegate6(R, P1, P2, P3, P4, P5, P6)
{
    abstract R Eval(P1, P2, P3, P4, P5, P6);
    abstract AdvancedDelegate5!(R, P2, P3, P4, P5, P6) opCall(P1);
    abstract AdvancedDelegate4!(R, P3, P4, P5, P6) opCall(P1, P2);
    abstract AdvancedDelegate3!(R, P4, P5, P6) opCall(P1, P2, P3);
    abstract AdvancedDelegate2!(R, P5, P6) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate1!(R, P6) opCall(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5, P6);
}

class AdvancedDelegate7(R, P1, P2, P3, P4, P5, P6, P7)
{
    abstract R Eval(P1, P2, P3, P4, P5, P6, P7);
    abstract AdvancedDelegate6!(R, P2, P3, P4, P5, P6, P7) opCall(P1);
    abstract AdvancedDelegate5!(R, P3, P4, P5, P6, P7) opCall(P1, P2);
    abstract AdvancedDelegate4!(R, P4, P5, P6, P7) opCall(P1, P2, P3);
    abstract AdvancedDelegate3!(R, P5, P6, P7) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate2!(R, P6, P7) opCall(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate1!(R, P7) opCall(P1, P2, P3, P4, P5, P6);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5, P6, P7);
}

class AdvancedDelegate8(R, P1, P2, P3, P4, P5, P6, P7, P8)
{
    abstract R Eval(P1, P2, P3, P4, P5, P6, P7, P8);
    abstract AdvancedDelegate7!(R, P2, P3, P4, P5, P6, P7, P8) opCall(P1);
    abstract AdvancedDelegate6!(R, P3, P4, P5, P6, P7, P8) opCall(P1, P2);
    abstract AdvancedDelegate5!(R, P4, P5, P6, P7, P8) opCall(P1, P2, P3);
    abstract AdvancedDelegate4!(R, P5, P6, P7, P8) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate3!(R, P6, P7, P8) opCall(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate2!(R, P7, P8) opCall(P1, P2, P3, P4, P5, P6);
    abstract AdvancedDelegate1!(R, P8) opCall(P1, P2, P3, P4, P5, P6, P7);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5, P6, P7, P8);
}

class AdvancedDelegate9(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)
{
    abstract R Eval(P1, P2, P3, P4, P5, P6, P7, P8, P9);
    abstract AdvancedDelegate8!(R, P2, P3, P4, P5, P6, P7, P8, P9) opCall(P1);
    abstract AdvancedDelegate7!(R, P3, P4, P5, P6, P7, P8, P9) opCall(P1, P2);
    abstract AdvancedDelegate6!(R, P4, P5, P6, P7, P8, P9) opCall(P1, P2, P3);
    abstract AdvancedDelegate5!(R, P5, P6, P7, P8, P9) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate4!(R, P6, P7, P8, P9) opCall(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate3!(R, P7, P8, P9) opCall(P1, P2, P3, P4, P5, P6);
    abstract AdvancedDelegate2!(R, P8, P9) opCall(P1, P2, P3, P4, P5, P6, P7);
    abstract AdvancedDelegate1!(R, P9) opCall(P1, P2, P3, P4, P5, P6, P7, P8);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5, P6, P7, P8, P9);
}

class AdvancedDelegate10(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)
{
    abstract R Eval(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
    abstract AdvancedDelegate9!(R, P2, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1);
    abstract AdvancedDelegate8!(R, P3, P4, P5, P6, P7, P8, P9, P10) opCall(P1, P2);
    abstract AdvancedDelegate7!(R, P4, P5, P6, P7, P8, P9, P10) opCall(P1, P2, P3);
    abstract AdvancedDelegate6!(R, P5, P6, P7, P8, P9, P10) opCall(P1, P2, P3, P4);
    abstract AdvancedDelegate5!(R, P6, P7, P8, P9, P10) opCall(P1, P2, P3, P4, P5);
    abstract AdvancedDelegate4!(R, P7, P8, P9, P10) opCall(P1, P2, P3, P4, P5, P6);
    abstract AdvancedDelegate3!(R, P8, P9, P10) opCall(P1, P2, P3, P4, P5, P6, P7);
    abstract AdvancedDelegate2!(R, P9, P10) opCall(P1, P2, P3, P4, P5, P6, P7, P8);
    abstract AdvancedDelegate1!(R, P10) opCall(P1, P2, P3, P4, P5, P6, P7, P8, P9);
    abstract AdvancedDelegate0!(R) opCall(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10);
}

