
module advanceddelegate.helpers;

private import advanceddelegate.base;
private import advanceddelegate.adelegate;
private import advanceddelegate.afunction;

AdvancedDelegate0!(R) AdvancedDelegate(R) (R delegate() dg)
{
    return new AdvancedDelegateP0G0!(R)(dg);
}

AdvancedDelegate0!(R) AdvancedFunction(R) (R function() dg)
{
    return new AdvancedFunctionP0G0!(R)(dg);
}

AdvancedDelegate1!(R, P1) AdvancedDelegate(R, P1) (R delegate(P1) dg)
{
    return new AdvancedDelegateP1G0!(R, P1)(dg);
}

AdvancedDelegate1!(R, P1) AdvancedFunction(R, P1) (R function(P1) dg)
{
    return new AdvancedFunctionP1G0!(R, P1)(dg);
}

AdvancedDelegate2!(R, P1, P2) AdvancedDelegate(R, P1, P2) (R delegate(P1, P2) dg)
{
    return new AdvancedDelegateP2G0!(R, P1, P2)(dg);
}

AdvancedDelegate2!(R, P1, P2) AdvancedFunction(R, P1, P2) (R function(P1, P2) dg)
{
    return new AdvancedFunctionP2G0!(R, P1, P2)(dg);
}

AdvancedDelegate3!(R, P1, P2, P3) AdvancedDelegate(R, P1, P2, P3) (R delegate(P1, P2, P3) dg)
{
    return new AdvancedDelegateP3G0!(R, P1, P2, P3)(dg);
}

AdvancedDelegate3!(R, P1, P2, P3) AdvancedFunction(R, P1, P2, P3) (R function(P1, P2, P3) dg)
{
    return new AdvancedFunctionP3G0!(R, P1, P2, P3)(dg);
}

AdvancedDelegate4!(R, P1, P2, P3, P4) AdvancedDelegate(R, P1, P2, P3, P4) (R delegate(P1, P2, P3, P4) dg)
{
    return new AdvancedDelegateP4G0!(R, P1, P2, P3, P4)(dg);
}

AdvancedDelegate4!(R, P1, P2, P3, P4) AdvancedFunction(R, P1, P2, P3, P4) (R function(P1, P2, P3, P4) dg)
{
    return new AdvancedFunctionP4G0!(R, P1, P2, P3, P4)(dg);
}

AdvancedDelegate5!(R, P1, P2, P3, P4, P5) AdvancedDelegate(R, P1, P2, P3, P4, P5) (R delegate(P1, P2, P3, P4, P5) dg)
{
    return new AdvancedDelegateP5G0!(R, P1, P2, P3, P4, P5)(dg);
}

AdvancedDelegate5!(R, P1, P2, P3, P4, P5) AdvancedFunction(R, P1, P2, P3, P4, P5) (R function(P1, P2, P3, P4, P5) dg)
{
    return new AdvancedFunctionP5G0!(R, P1, P2, P3, P4, P5)(dg);
}

AdvancedDelegate6!(R, P1, P2, P3, P4, P5, P6) AdvancedDelegate(R, P1, P2, P3, P4, P5, P6) (R delegate(P1, P2, P3, P4, P5, P6) dg)
{
    return new AdvancedDelegateP6G0!(R, P1, P2, P3, P4, P5, P6)(dg);
}

AdvancedDelegate6!(R, P1, P2, P3, P4, P5, P6) AdvancedFunction(R, P1, P2, P3, P4, P5, P6) (R function(P1, P2, P3, P4, P5, P6) dg)
{
    return new AdvancedFunctionP6G0!(R, P1, P2, P3, P4, P5, P6)(dg);
}

AdvancedDelegate7!(R, P1, P2, P3, P4, P5, P6, P7) AdvancedDelegate(R, P1, P2, P3, P4, P5, P6, P7) (R delegate(P1, P2, P3, P4, P5, P6, P7) dg)
{
    return new AdvancedDelegateP7G0!(R, P1, P2, P3, P4, P5, P6, P7)(dg);
}

AdvancedDelegate7!(R, P1, P2, P3, P4, P5, P6, P7) AdvancedFunction(R, P1, P2, P3, P4, P5, P6, P7) (R function(P1, P2, P3, P4, P5, P6, P7) dg)
{
    return new AdvancedFunctionP7G0!(R, P1, P2, P3, P4, P5, P6, P7)(dg);
}

AdvancedDelegate8!(R, P1, P2, P3, P4, P5, P6, P7, P8) AdvancedDelegate(R, P1, P2, P3, P4, P5, P6, P7, P8) (R delegate(P1, P2, P3, P4, P5, P6, P7, P8) dg)
{
    return new AdvancedDelegateP8G0!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg);
}

AdvancedDelegate8!(R, P1, P2, P3, P4, P5, P6, P7, P8) AdvancedFunction(R, P1, P2, P3, P4, P5, P6, P7, P8) (R function(P1, P2, P3, P4, P5, P6, P7, P8) dg)
{
    return new AdvancedFunctionP8G0!(R, P1, P2, P3, P4, P5, P6, P7, P8)(dg);
}

AdvancedDelegate9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) AdvancedDelegate(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) (R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9) dg)
{
    return new AdvancedDelegateP9G0!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg);
}

AdvancedDelegate9!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) AdvancedFunction(R, P1, P2, P3, P4, P5, P6, P7, P8, P9) (R function(P1, P2, P3, P4, P5, P6, P7, P8, P9) dg)
{
    return new AdvancedFunctionP9G0!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9)(dg);
}

AdvancedDelegate10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) AdvancedDelegate(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) (R delegate(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) dg)
{
    return new AdvancedDelegateP10G0!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg);
}

AdvancedDelegate10!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) AdvancedFunction(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) (R function(P1, P2, P3, P4, P5, P6, P7, P8, P9, P10) dg)
{
    return new AdvancedFunctionP10G0!(R, P1, P2, P3, P4, P5, P6, P7, P8, P9, P10)(dg);
}

